#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "dtypes.h"
#include "opcodes.h"

int muestra_instr(uint16 cop, uint16 pc, int modo)
{
	uint8 ra,rb,rd,cc,op,n;
	int16 desp;
	int i;
	const char *rgn[8]={"PC","SP","LR","R3","R4","R5","R6","R7"};

	n=rb=cop & 7;  
	desp=cop & 0x1ff; if (desp & 0x100) desp |=0xfe00;
	ra=(cop>>3) & 7;
	rd=(cop>>6) & 7;
	cc=(cop>>9) & 7;
	op=(cop>>12) & 15;
	
	if (!cc) { printf("NOP"); return 0; }
	printf("%s",instr[op]);
	i=strlen(instr[op]);
	if (cc!=1) {printf(".%s",ccond[cc]); i+=strlen(ccond[cc])+1;}
	for (;i<8;i++) putchar(' ');
	switch(op) {
	case ADD:
	case SUB:
	case ADC:
	case SBB:
	case AND:
	case OR:
	case XOR:
		printf("%s,%s,%s",rgn[ra],rgn[rb],rgn[rd]);
		break;
	case ADDQ:
	case SUBQ:
		printf("%s,%d,%s",rgn[ra],rb,rgn[rd]);
		break;
	case NOT:
	case NEG:
	case ROR:
		printf("%s,%s",rgn[rb],rgn[rd]);
		break;
	case LD:
		printf("(%s),%s",rgn[rb],rgn[rd]);
		if (!rb) return 1;
		break;
	case ST:
		printf("%s,(%s)",rgn[ra],rgn[rb]);
		break;
	case JR:
		if (modo==0) {
		    if (desp>=0) putchar('+');
		    printf("%d",desp);
		    i=0; n=abs(desp); while (n) {i++; n/=10;}
		    for(;i<12;i++) putchar(' ');
		    printf("; 0x%04X",pc+desp);
		} else {
		    printf("0x%04X",pc+desp);
		}
		break;
	case RETI:
		break;
	}
	return 0;
}

void loadhex(char *fn,int modo)
{
    int i,dir,ddir=-1,w=0;
    short dato;
    char *p,*pp,buf[256];
    FILE *fp;
    
    if ((fp=fopen(fn,"r"))==NULL) exit(0);
    
    for (dir=0;;) {
        fgets(buf,255,fp);
	if (feof(fp)) break;
	p=buf;
	if (*p=='@') {
	   dir=strtol(++p,&pp,16);
	   putchar('\n');
	   if (modo==0) printf("     ");
	   printf ("        ORG     0x%04X\n",dir);
	   continue;
	}
	
	dato=strtol(p,&pp,16);
	
	if (modo==0) printf("%04X - %04X  ",dir,dato&0xffff);
	else printf("        ");
	if (dir!=ddir) {
	    if (muestra_instr(dato,dir+1,modo)) ddir=dir+1;
	} else {
	    printf("WORD    ");
	    if (modo==0) {
	    	if (dato>=0) putchar('+');
	    	printf("%d",dato);
	    } else printf("0x%04X",dato);
	}
	printf("\n");
	dir++;	
    }
}


main(int argc, char **argv)
{
     int modo=0;
     if (argc<2) {
         printf("Uso: %s fichero.hex [modo]\n",argv[0]);
	 exit(0);
     }
     if (argc>2) modo=atoi(argv[2]);
     loadhex(argv[1],modo);    
}
