	org 0	; RESET vector
	
	jr	start
	xor	pc,pc,sp
	
	org 2	; IRQ vector
	
	reti
	nop

start:	xor	sp,sp,lr
	xor	sp,sp,r3
	xor	sp,sp,r4
	xor	sp,sp,r5
	xor	sp,sp,r6
	xor	sp,sp,r7
	
	ld	(pc),r7		; start with number 2
	word 	1234	
	
	; divide by 10
	xor	r3,r3,r3	; remainder
	or	r7,r7,r6
	ld	(pc),r5		; divider
	word	10
	xor	r4,r4,r4	; number of digits

l35:	ld	(pc),lr		; loop counter
	word	16
	
l4:	add	r6,r6,r6	; shift left
	adc	r3,r3,r3
	sub	r3,r5,r3
	add.c	r3,r5,r3	; restore value
	addq.nc	r6,1,r6		; update quotient
l6:	subq	lr,1,lr
	jr.nz	l4
	nop

	ld	(pc),lr
	word	48		; ASCII '0'
	add	lr,r3,r3
	subq	sp,1,sp		; to stack
	st	r3,(sp)
	addq	r4,1,r4
	or	r6,r6,r6
	jr.nz	l35
	xor	r3,r3,r3
	
l7:	ld	(sp),r3		; from stack
	addq	pc,2,lr
	jr	putch		; print it
	addq	sp,1,sp
	subq	r4,1,r4
	jr.nz	l7
	nop
	
	ld	(pc),r3
	word	32		; space
	addq	pc,2,lr
	jr	putch		; print it
	nop

hang:	jr	hang
	nop		

;-------------------------------------
; routine to print R3 as an ASCII char

putch:	
;	or	lr,lr,pc	; return (dummy print)
;	nop

	subq	sp,1,sp		; save registers
	st	lr,(sp)
	subq	sp,1,sp	
	st	r4,(sp)
	
	ld	(pc),lr		; load vmem pointer to r4
	word	pchar
	ld	(lr),r4
	st	r3,(r4)		; store char to vmem
	addq	r4,1,r4		; increment pointer
	st	r4,(lr)		; save pointer
	
	ld	(sp),r4		; restore registers
	addq	sp,1,sp
	ld	(sp),lr
	or	lr,lr,pc	; return
	addq	sp,1,sp

pchar:	word	4096	; Pointer to video memory
array:
