
module ram64Kx8(data,address,wr,rd);
  parameter delay = 1;
  inout [ 7:0] data;
  input [15:0] address;
  input wr,rd;

  reg [7:0] memoryspace [65535:0];
  wire [7:0] localdataout;

  // The value at the current address is
  // always at the input of the buffer
  assign localdataout = memoryspace[address];

  // A rising edge of the write pulse
  // actually puts the data into memory
  always @(negedge wr)
     #delay memoryspace[address] <= data;

  // Write must be low to prevent
  // conflicts during a read!
  and #delay u1(outputenable,rd,~wr);

  // If a read occurs then just
  // enable the output wires onto
  // the bus.
  tribuf 8 #delay outbuf(data,localdataout, outputenable);

endmodule
