;
; Registros "alias"
; PC = R0  (forzado por el hardware)
; SP = R1  (arbitrario) 
; LR = R2  (arbitrario)
;
	org 0		; Reset
	jr start
	xor pc,pc,sp	; Pila al final de la RAM

	org 2		; Rutina de interrupcion
	subq sp,1,sp
	st r7,(sp)
	subq sp,1,sp
	st r6,(sp)
	ld (pc),r7
	word nint
	ld (r7),r6
	addq r6,1,r6	; incremente contador de interrupciones
	st r6,(r7)
	addq r7,1,r7
	ld (sp),r6
	addq sp,1,sp
	ld (sp),r7
	addq sp,1,sp
	reti		; Rutina de interrupcion
	nop
	
start:	; borramos pantalla con caracter fijo
	ld (pc),r7	; puntero
	word 4096
	ld (pc),r6	; contador
	word 1920
	ld (pc),r4	; caracter '*'
	word 42

buc:	st r4,(r7)
	subq r6,1,r6
	jr.nz buc
	addq r7,1,r7
	ld (pc),r4
	word 35		; caracter '#'
	

uno:	xor sp,sp,r6	; Y
	xor sp,sp,r5	; X
	addq r5,1,r7	; inc X
	addq r5,1,r3	; inc Y

buc1:	addq pc,2,lr
	jr putxy	;imprimimos #
	subq r4,3,r4    ;cambio a espacio (tras jr)
	add r5,r7,r5	;incrementamos X
	neg.z r7,r7	;si X=0 invertimos incremento X 
	ld (pc),lr
	word 79
	sub r5,lr,lr
	neg.z r7,r7	;si X=79 invertimos incremento X

	add r6,r3,r6	;incrementamos Y 
	neg.z r3,r3	;si Y=0 invertimos incremento Y
	ld (pc),lr
        word 23   
        sub r6,lr,lr
        neg.z r3,r3 	;si Y=23 invertimos incremento Y

	addq pc,2,lr
        jr putxy	;imprimimos espacio
	addq r4,3,r4	;cambio a # (tras jr)
        addq pc,2,lr
        jr retardoint
        nop

	jr buc1
	nop
	

; rutina putxy
; R6: y
; R5: x
; R4: caracter a imprimir
; R1: direccin de retorno

putxy:	subq sp,1,sp
	st r3,(sp)
	subq sp,1,sp
	st r7,(sp)

	add r6,r6,r7 ; y*2
	add r7,r7,r7 ; y*4
	add r6,r7,r7 ; y*5
	add r7,r7,r7 ; y*10
	add r7,r7,r7 ; y*20
	add r7,r7,r7 ; y*40
	add r7,r7,r7 ; y*80
	add r5,r7,r7 ; y*80+x
	ld (pc),r3
	word 4096
	add r3,r7,r7 ; dir video
	st r4,(r7)

	ld (sp),r7
	addq sp,1,sp
	ld (sp),r3
	or lr,lr,pc  ; retorno
	addq sp,1,sp ; instruccin precargada

retardoint:
	subq sp,1,sp
	st r5,(sp)
	subq sp,1,sp
	st r3,(sp)
	subq sp,1,sp
	st r4,(sp)
	ld (pc),r4
	word nint 
	ld (r4),r5
bucret:	ld (r4),r3
	sub r3,r5,r3
	jr.z bucret
	nop
	ld (sp),r4
	addq sp,1,sp
	ld (sp),r3
	addq sp,1,sp
	ld (sp),r5
	or lr,lr,pc  ; retorno
	addq sp,1,sp ; instruccin precargada
	
nint:	word 0x0000

